## vim 9.1.1113

=== runtime/syntax/Makefile ===
# Portable Makefile for running syntax tests.

# To run the test manually:
# ../../src/vim -u 'testdir/runtest.vim' --cmd 'breakadd func RunTest'

# Override this if needed, the default assumes Vim was build in the src dir.
#VIMPROG = vim
VIMPROG = ../../src/vim

# "runtime" relative to "runtime/syntax/testdir"
VIMRUNTIME = ../..

# Uncomment this line to use valgrind for memory leaks and extra warnings.
# VALGRIND = valgrind --tool=memcheck --leak-check=yes --num-callers=45 --log-file=valgrind.$*

# ENVVARS = LC_ALL=C LANG=C LANGUAGE=C
# Run the syntax tests with a C locale
ENVVARS = LC_ALL=C

RUN_VIMTEST = VIMRUNTIME=$(VIMRUNTIME) $(VALGRIND) $(ENVVARS) ../$(VIMPROG) -f $(GUI_FLAG)

# Uncomment this line for debugging
# DEBUGLOG = --log testlog

# Run the tests that didn't run yet or failed previously.
# If a test succeeds a testdir/done/{name} file will be written.
# If a test fails a testdir/failed/{name}.dump file will be written.
# Progress and error messages can be found in "testdir/messages".
# Comment out the "> /dev/null" part to see the in-progress Vim behaviors.
test:
	@# the "vimcmd" file is used by the screendump utils
	@echo "../$(VIMPROG)" > testdir/vimcmd
	@echo "$(RUN_VIMTEST)" >> testdir/vimcmd
	VIMRUNTIME=$(VIMRUNTIME) $(ENVVARS) $(VIMPROG) --clean --not-a-term $(DEBUGLOG) -u testdir/runtest.vim > /dev/null 
	@rm -f testdir/Xfilter
	@# FIXME: Temporarily show the whole file to find out what goes wrong
	@#if [ -f testdir/messages ]; then tail -n 6 testdir/messages; fi
	@if [ -f testdir/messages ]; then cat testdir/messages; fi


clean testclean:
	rm -f testdir/failed/* testdir/done/* testdir/vimcmd testdir/messages testdir/Xtestscript testdir/Xfilter

# All initial phony targets; these names may clash with file extensions.
phonies = clean test testclean

# Collect all input filenames and their file extensions.
testnames != set +f; \
awk 'BEGIN { \
    for (i = 1; i < ARGC; i++) { \
        split(ARGV[i], names, /\//); \
        split(names[3], parts, /\./); \
        exts[parts[2]]; \
        print names[3]; \
    } \
    split("$(phonies)", scratch); \
    for (phony in scratch) \
        phonies[scratch[phony]]; \
    for (ext in exts) \
        print ext ((ext in phonies) ? "_" : ""); \
}' testdir/input/*.*

.PHONY: self-testing $(testnames)

$(testnames)::
	@echo $@ >> testdir/Xfilter

self-testing:: $(testnames)
	@echo self-testing > testdir/Xfilter

=== debian/changelog ===
vim (2:9.1.1113-1deepin1) unstable; urgency=medium

  * Set NoDisplay=true for vim.desktop

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 19 Mar 2025 09:21:18 +0800

vim (2:9.1.1113-1) unstable; urgency=medium

  [ James McCoy ]
  * Merge upstream tag v9.1.1113
    + Security fixes:
      - 9.1.1003: heap-buffer overflow with visual mode when using :all,
        CVE-2025-22134
      - 9.1.1043: segfault in win_line(), CVE-2025-24014
      - 9.1.1097: crash when using --log with non-existent path, CVE-2025-1215

  [ Andrea Pappacoda ]
  * Drop backspace and history from debian.vim (Closes: #1095155)

 -- James McCoy <jamessan@debian.org>  Sat, 15 Feb 2025 20:43:27 -0500

vim (2:9.1.0967-2) unstable; urgency=medium

  * Revert "patch 9.1.0949: popups inconsistently shifted to the left",
    since it breaks vim-youcompleteme's autopkgtests. (Closes: #1091729)

 -- James McCoy <jamessan@debian.org>  Fri, 10 Jan 2025 06:30:59 -0500

## vim 9.1.1230

=== src/Makefile ===
# Makefile for Vim on Unix and Unix-like systems	vim:ts=8:sw=8:tw=78
#
# This Makefile is loosely based on the GNU Makefile conventions found in
# standards.info.
#
# Compiling Vim, summary:
#
#	3. make
#	5. make install
#
# Compiling Vim, details:
#
# Edit this file for adjusting to your system. You should not need to edit any
# other file for machine specific things!
# The name of this file MUST be Makefile (note the uppercase 'M').
#
# 1. Edit this Makefile  {{{1
#	The defaults for Vim should work on most machines, but you may want to
#	uncomment some lines or make other changes below to tune it to your
#	system, compiler or preferences.  Uncommenting means that the '#' in
#	the first column of a line is removed.
#	- If you want a version of Vim that is small and starts up quickly,
#	  you might want to disable the GUI, X11, Perl, Python and Tcl.
#	- Uncomment the line with --disable-gui if you have Motif and/or GTK
#	  but don't want to make gvim (the GUI version of Vim with nice
#	  menus and scrollbars, but makes Vim bigger and startup slower).
#	- Uncomment --disable-darwin if on Mac OS X but you want to compile a
#	  Unix version.
#	- Uncomment the line "CONF_OPT_X = --without-x" if you have X11 but
#	  want to disable using X11 libraries.	This speeds up starting Vim,
#	  but the window title will not be set and the X11 selection can not
#	  be used.
#	- Uncomment the line "CONF_OPT_XSMP = --disable-xsmp" if you have the
#	  X11 Session Management Protocol (XSMP) library (libSM) but do not
#	  want to use it.
#	  This can speedup Vim startup but Vim loses the ability to catch the
#	  user logging out from session-managers like GNOME and work
#	  could be lost.
#	- Uncomment one or more of these lines to include an interface;
#	  each makes Vim quite a bit bigger:
#		--enable-luainterp	for Lua interpreter
#		--enable-mzschemeinterp	for MzScheme interpreter
#		--enable-perlinterp	for Perl interpreter
#		--enable-python3interp	for Python3 interpreter
#		--enable-pythoninterp	for Python interpreter
#		--enable-rubyinterp	for Ruby interpreter
#		--enable-tclinterp	for Tcl interpreter
#		--enable-cscope		for Cscope interface
#	- Uncomment one of the lines with --with-features= to enable a set of
#	  features (but not the interfaces just mentioned).
#	- Uncomment the line with --disable-acl to disable ACL support even
#	  though your system supports it.
#	- Uncomment the line with --disable-gpm to disable gpm support
#	  even though you have gpm libraries and includes.
#	- Uncomment the line with --disable-sysmouse to disable sysmouse
#	  support even though you have /dev/sysmouse and includes.
#	- Uncomment one of the lines with CFLAGS and/or CC if you have
#	  something very special or want to tune the optimizer.
#	- Search for the name of your system to see if it needs anything
#	  special.
#	- A few versions of make use '.include "file"' instead of 'include
#	  file'.  Adjust the include line below if yours does.
#
# 2. Edit feature.h  {{{1
#	Only if you do not agree with the default compile features, e.g.:
#	- you want Vim to be as vi compatible as it can be
#	- you want to use Emacs tags files
#	- you want right-to-left editing (Hebrew)
#	- you want 'langmap' support (Greek)
#	- you want to remove features to make Vim smaller
#
# 3. "make"  {{{1
#	Will first run ./configure with the options in this file. Then it will
#	start make again on this Makefile to do the compiling. You can also do
#	this in two steps with:
#		make config
#		make
#	The configuration phase creates/overwrites auto/config.h and
#	auto/config.mk.
#	The configure script is created with "make autoconf".  It can detect
#	different features of your system and act accordingly.  However, it is
#	not correct for all systems.  Check this:
#	- If you have X windows, but configure could not find it or reported
#	  another include/library directory then you wanted to use, you have
#	  to set CONF_OPT_X below.  You might also check the installation of
#	  xmkmf.
#	- If you have --enable-gui=motif and have Motif on your system, but
#	  configure reports "checking for location of gui... <not found>", you
#	  have to set GUI_INC_LOC and GUI_LIB_LOC below.
#	If you changed something, do this to run configure again:
#		make reconfig
#
#	- If you do not trust the automatic configuration code, then inspect
#	  auto/config.h and auto/config.mk, before starting the actual build
#	  phase. If possible edit this Makefile, rather than auto/config.mk --
#	  especially look at the definition of VIMLOC below. Note that the
#	  configure phase overwrites auto/config.mk and auto/config.h again.
#	- If you get error messages, find out what is wrong and try to correct
#	  it in this Makefile. You may need to do "make reconfig" when you
#	  change anything that configure uses (e.g. switching from an old C
#	  compiler to an ANSI C compiler). Only when auto/configure does
#	  something wrong you may need to change one of the other files. If
#	  you find a clean way to fix the problem, consider sending a note to
#	  the author of autoconf (bug-gnu-utils@prep.ai.mit.edu) or Vim
#	  (vim-dev@vim.org). Don't bother to do that when you made a hack
#	  solution for a non-standard system.
#
# 4. "make test"  {{{1
#	This is optional.  This will run Vim scripts on a number of test
#	files, and compare the produced output with the expected output.
#	If all is well, you will get the "ALL DONE" message in the end.  If a
#	test fails you get "TEST FAILURE".  See below (search for "/^test").
#
# 5. "make install"  {{{1
#	If the new Vim seems to be working OK you can install it and the
#	documentation in the appropriate location. The default is
#	"/usr/local".  Change "prefix" below to change the location.
#	"auto/pathdef.c" will be compiled again after changing this to make
#	the executable know where the help files are located.
#	Note that any existing executable is removed or overwritten.  If you
#	want to keep it you will have to make a backup copy first.
#	The runtime files are in a different directory for each version.  You
#	might want to delete an older version.
#	If you don't want to install everything, there are other targets:
#		make installvim		only installs Vim, not the tools
#		make installvimbin	only installs the Vim executable
#		make installruntime	installs most of the runtime files
#		make installrtbase	only installs the Vim help and
#							runtime files
#		make installlinks	only installs the Vim binary links
#		make installmanlinks	only installs the Vim manpage links
#		make installmacros	only installs the Vim macros
#		make installpack	only installs the packages
#		make installtutorbin	only installs the Vim tutor program
#		make installtutor	only installs the Vim tutor files
#		make installspell	only installs the spell files
#		make installtools	only installs xxd
#	If you install Vim, not to install for real but to prepare a package
#	or RPM, set DESTDIR to the root of the tree.
#
# 6. Use Vim until a new version comes out.  {{{1
#
# 7. "make uninstall_runtime"  {{{1
#	Will remove the runtime files for the current version.	This is safe
#	to use while another version is being used, only version-specific
#	files will be deleted.
#	To remove the runtime files of another version:
#		make uninstall_runtime VIMRTDIR=/vim54
#	If you want to delete all installed files, use:
#		make uninstall
#	Note that this will delete files that have the same name for any
#	version, thus you might need to do a "make install" soon after this.
#	Be careful not to remove a version of Vim that is still being used!
#	To find out which files and directories will be deleted, use:
#		make -n uninstall
# }}}
#
### This Makefile has been successfully tested on many systems. {{{
### Only the ones that require special options are mentioned here.
### Check the (*) column for remarks, listed below.
### Later code changes may cause small problems, otherwise Vim is supposed to
### compile and run without problems.

#system:	      configurations:		     version (*) tested by:
#-------------	      ------------------------	     -------  -  ----------
#AIX 3.2.5	      cc (not gcc)   -			4.5  (M) Will Fiveash
#AIX 4		      cc	     +X11 -GUI		3.27 (4) Axel Kielhorn
#AIX 4.1.4	      cc	     +X11 +GUI		4.5  (5) Nico Bakker
#AIX 4.2.1	      cc				5.2k (C) Will Fiveash
#AIX 4.3.3.12	      xic 3.6.6				5.6  (5) David R. Favor
#A/UX 3.1.1	      gcc	     +X11		4.0  (6) Jim Jagielski
#BSDI 2.1 (x86)       shlicc2 gcc-2.6.3 -X11 X11R6	4.5  (1) Jos Backus
#BSD/OS 3.0 (x86)     gcc gcc-2.7.2.1 -X11 X11R6	4.6c (1) Jos Backus
#CX/UX 6.2	      cc	     +X11 +GUI_Mofif	5.4  (V) Kipp E. Howard
#DG/UX 5.4*	      gcc 2.5.8      GUI		5.0e (H) Jonas Schlein
#DG/UX 5.4R4.20       gcc 2.7.2      GUI		5.0s (H) Rocky Olive
#HP-UX (most)	      c89 cc				5.1  (2) Bram Moolenaar
#HP-UX_9.04	      cc	     +X11 +Motif	5.0  (2) Carton Lao
#Linux 2.0	      gcc-2.7.2      Infomagic Motif	4.3  (3) Ronald Rietman
#NEC UP4800 UNIX_SV 4.2MP  cc	     +X11R6 Motif	4.6b (Q) Lennart Schultz
#NetBSD 1.0A	      gcc-2.4.5      -X11 -GUI		3.21 (X) Juergen Weigert
#QNX 4.2	      wcc386-10.6    -X11		4.2  (D) G.F. Desrochers
#QNX 4.23	      Watcom	     -X11		4.2  (F) John Oleynick
#SCO Unix v3.2.5      cc	     +X11 Motif		3.27 (C) M. Kuperblum
#SCO Open Server 5    gcc 2.7.2.3    +X11 +GUI Motif	5.3  (A) Glauber Ribeiro
#SINIX-N 5.43 RM400 R4000   cc	     +X11 +GUI		5.0l (I) Martin Furter
#SINIX-Z 5.42 i386    gcc 2.7.2.3    +X11 +GUI Motif	5.1  (I) Joachim Fehn
#SINIX-Y 5.43 RM600 R4000  gcc 2.7.2.3 +X11 +GUI Motif	5.1  (I) Joachim Fehn
#Reliant/SINIX 5.44   cc	     +X11 +GUI		5.5a (I) B. Pruemmer
#SNI Targon31 TOS 4.1.11 gcc-2.4.5   +X11 -GUI		4.6c (B) Paul Slootman
#Solaris 2.4 (Sparc)  cc	     +X11 +GUI		3.29 (9) Glauber
#Solaris 2.4/2.5      clcc	     +X11 -GUI openwin	3.20 (7) Robert Colon
#Solaris 2.5 (sun4m)  cc (SC4.0)     +X11R6 +GUI (CDE)	4.6b (E) Andrew Large
#Solaris 2.5	      gcc 2.5.6      +X11 Motif		5.0m (R) Ant. Colombo
#Solaris 2.6	      gcc 2.8.1      ncurses		5.3  (G) Larry W. Virden
#Solaris with -lthread					5.5  (W) K. Nagano
#Solaris	      gcc				     (b) Riccardo
#SunOS 4.1.x			     +X11 -GUI		5.1b (J) Bram Moolenaar
#SUPER-UX 6.2 (NEC SX-4) cc	     +X11R6 Motif	4.6b (P) Lennart Schultz
#Tandem/NSK						     (c) Matthew Woehlke
#Unisys 6035	      cc	     +X11 Motif		5.3  (8) Glauber Ribeiro
#ESIX V4.2	      cc	     +X11		6.0  (a) Reinhard Wobst
# }}}

# (*)  Remarks: {{{
#
# (1)  Uncomment line below for shlicc2
# (2)  HPUX with compile problems or wrong digraphs, uncomment line below
# (3)  Infomagic Motif needs GUI_LIB_LOC and GUI_INC_LOC set, see below.
#      And add "-lXpm" to MOTIF_LIBS2.
# (4)  For cc the optimizer must be disabled (use CFLAGS= after running
#      configure) (symptom: ":set termcap" output looks weird).
# (5)  Compiler may need extra argument, see below.
# (6)  See below for a few lines to uncomment
# (7)  See below for lines which enable the use of clcc
# (8)  Needs some EXTRA_LIBS, search for Unisys below
# (9)  Needs an extra compiler flag to compile gui_at_sb.c, see below.
# (A)  May need EXTRA_LIBS, see below
# (B)  Can't compile GUI because there is no waitpid()...  Disable GUI below.
# (C)  Force the use of curses instead of termcap, see below.
# (D)  Uncomment lines below for QNX
# (E)  You might want to use termlib instead of termcap, see below.
# (F)  See below for instructions.
# (G)  Using ncurses version 4.2 has reported to cause a crash.  Use the
#      Sun curses library instead.
# (H)  See line for EXTRA_LIBS below.
# (I)  SINIX-N 5.42 and 5.43 need some EXTRA_LIBS.  Also for Reliant-Unix.
# (J)  If you get undefined symbols, see below for a solution.
# (K)  See lines to uncomment below for machines with 64 bit pointers.
# (L)  For Silicon Graphics O2 workstations remove "-lnsl" from auto/config.mk
# (M)  gcc version cygnus-2.0.1 does NOT work (symptom: "dl" deletes two
#      characters instead of one).
# (N)  SCO with decmouse.

=== runtime/doc/Makefile ===
#
# Makefile for the Vim documentation on Unix
#
# If you get "don't know how to make scratch", first run make in the source
# directory.  Or remove the include below.

AWK = awk

VIMPROG = ../../src/vim

# include the config.mk from the source directory.  It's only needed to set
# AWK, used for "make html".  Comment this out if the include gives problems.
include ../../src/auto/config.mk

# Common components
include Make_all.mak

.SUFFIXES:
.SUFFIXES: .c .o .txt .html
.PHONY: all vimtags noerrors perlhtml clean test_urls

all: tags vim.man evim.man vimdiff.man vimtutor.man xxd.man $(CONVERTED)

# Use Vim to generate the tags file.  Can only be used when Vim has been
# compiled.  Supports multiple languages.
vimtags: $(DOCS)
	@$(VIMPROG) --clean -esX -V1 -u doctags.vim

# Use "doctags" to generate the tags file.  Only works for English!
tags: doctags $(DOCS)
	./doctags $(DOCS) | LANG=C LC_ALL=C sort >$@
	uniq -d -2 tags

doctags: doctags.c
	$(CC) doctags.c -o doctags

vim.man: vim.1
	nroff -man $? | sed -e s/.//g > $@

evim.man: evim.1
	nroff -man $? | sed -e s/.//g > $@

vimdiff.man: vimdiff.1
	nroff -man $? | sed -e s/.//g > $@

vimtutor.man: vimtutor.1
	nroff -man $? | sed -e s/.//g > $@

xxd.man: xxd.1
	nroff -man $? | sed -e s/.//g > $@

# Awk version of .txt to .html conversion.
html: noerrors tags $(HTMLS)
	@if test -f errors.log; then more errors.log; fi

noerrors:
	-rm -f errors.log

$(HTMLS): tags.ref

.txt.html:
	$(AWK) -f makehtml.awk $< >$@

# index.html is the starting point for HTML, but for the help files it is
# help.txt.  Therefore use vimindex.html for index.txt.
index.html: help.txt
	$(AWK) -f makehtml.awk $? >$@

vimindex.html: index.txt
	$(AWK) -f makehtml.awk $? >$@

tags.ref tags.html: tags
	$(AWK) -f maketags.awk tags >tags.html

# Perl version of .txt to .html conversion.
# There can't be two rules to produce a .html from a .txt file.
# Just run over all .txt files each time one changes.  It's fast anyway.
perlhtml: tags $(DOCS)
	./vim2html.pl tags $(DOCS)

# Check URLs in the help with "curl".
test_urls:
	$(VIMPROG) --clean -S test_urls.vim

clean:
	-rm -f doctags *.html tags.ref tags-* vim-stylesheet.css

# These files are in the extra archive, skip if not present

arabic.txt:
	touch $@

farsi.txt:
	touch $@

hebrew.txt:
	touch $@

russian.txt:
	touch $@

gui_w32.txt:
	touch $@

if_ole.txt:
	touch $@

os_390.txt:
	touch $@

os_amiga.txt:
	touch $@

os_beos.txt:
	touch $@

os_dos.txt:
	touch $@

os_haiku.txt:
	touch $@

os_mac.txt:
	touch $@

os_mint.txt:
	touch $@

os_msdos.txt:
	touch $@

os_os2.txt:
	touch $@

os_qnx.txt:
	touch $@

os_risc.txt:
	touch $@

os_win32.txt:
	touch $@

pi_netrw.txt: ../pack/dist/opt/netrw/doc/netrw.txt
	cp ../pack/dist/opt/netrw/doc/netrw.txt $@

vietnamese.txt:
	touch $@

# In *BSD, the variable '$<' is used in suffix-transformation rules (in GNU this
# is called "implicit rules", and in MS Windows it is called "inference rules").
# For code portability, it is better to use the '$?' variable for explicit rules.
# Especially since there is only one dependency and it should presumably always
# be newer than the target file.
vim-da.UTF-8.1: vim-da.1
	iconv -f latin1 -t UTF-8 $? >$@

vimdiff-da.UTF-8.1: vimdiff-da.1
	iconv -f latin1 -t UTF-8 $? >$@

vimtutor-da.UTF-8.1: vimtutor-da.1
	iconv -f latin1 -t UTF-8 $? >$@

vim-de.UTF-8.1: vim-de.1
	iconv -f latin1 -t UTF-8 $? >$@

vim-fr.UTF-8.1: vim-fr.1
	iconv -f latin1 -t UTF-8 $? >$@

evim-fr.UTF-8.1: evim-fr.1
	iconv -f latin1 -t UTF-8 $? >$@

vimdiff-fr.UTF-8.1: vimdiff-fr.1
	iconv -f latin1 -t UTF-8 $? >$@

vimtutor-fr.UTF-8.1: vimtutor-fr.1
	iconv -f latin1 -t UTF-8 $? >$@

xxd-fr.UTF-8.1: xxd-fr.1
	iconv -f latin1 -t UTF-8 $? >$@

vim-it.UTF-8.1: vim-it.1
	iconv -f latin1 -t UTF-8 $? >$@

evim-it.UTF-8.1: evim-it.1
	iconv -f latin1 -t UTF-8 $? >$@

vimdiff-it.UTF-8.1: vimdiff-it.1
	iconv -f latin1 -t UTF-8 $? >$@

vimtutor-it.UTF-8.1: vimtutor-it.1
	iconv -f latin1 -t UTF-8 $? >$@

xxd-it.UTF-8.1: xxd-it.1
	iconv -f latin1 -t UTF-8 $? >$@

vim-pl.UTF-8.1: vim-pl.1
	iconv -f latin2 -t UTF-8 $? >$@

evim-pl.UTF-8.1: evim-pl.1
	iconv -f latin2 -t UTF-8 $? >$@

vimdiff-pl.UTF-8.1: vimdiff-pl.1
	iconv -f latin2 -t UTF-8 $? >$@

vimtutor-pl.UTF-8.1: vimtutor-pl.1
	iconv -f latin2 -t UTF-8 $? >$@

xxd-pl.UTF-8.1: xxd-pl.1
	iconv -f latin2 -t UTF-8 $? >$@

vim-ru.UTF-8.1: vim-ru.1
	iconv -f KOI8-R -t UTF-8 $? >$@

evim-ru.UTF-8.1: evim-ru.1
	iconv -f KOI8-R -t UTF-8 $? >$@

vimdiff-ru.UTF-8.1: vimdiff-ru.1
	iconv -f KOI8-R -t UTF-8 $? >$@

vimtutor-ru.UTF-8.1: vimtutor-ru.1
	iconv -f KOI8-R -t UTF-8 $? >$@

xxd-ru.UTF-8.1: xxd-ru.1
	iconv -f KOI8-R -t UTF-8 $? >$@

vim-tr.UTF-8.1: vim-tr.1
	iconv -f latin5 -t UTF-8 $? >$@

evim-tr.UTF-8.1: evim-tr.1
	iconv -f latin5 -t UTF-8 $? >$@

vimdiff-tr.UTF-8.1: vimdiff-tr.1
	iconv -f latin5 -t UTF-8 $? >$@

vimtutor-tr.UTF-8.1: vimtutor-tr.1
	iconv -f latin5 -t UTF-8 $? >$@

=== runtime/syntax/Makefile ===
# Portable Makefile for running syntax tests.

# To run the test manually:
# ../../src/vim -u 'testdir/runtest.vim' --cmd 'breakadd func RunTest'

# Override this if needed, the default assumes Vim was built in the src dir.
#VIMPROG = vim
VIMPROG = ../../src/vim

# "runtime" relative to "runtime/syntax/testdir"
VIMRUNTIME = ../..

# Uncomment this line to use valgrind for memory leaks and extra warnings.
# VALGRIND = valgrind --tool=memcheck --leak-check=yes --num-callers=45 --log-file=valgrind.$*

# Trace ruler liveness on demand.
# VIM_SYNTAX_TEST_LOG = `pwd`/testdir/failed/00-TRACE_LOG

# ENVVARS = LC_ALL=C VIM_SYNTAX_TEST_LOG="$(VIM_SYNTAX_TEST_LOG)"
# ENVVARS = LC_ALL=C LANG=C LANGUAGE=C
# Run the syntax tests with a C locale
ENVVARS = LC_ALL=C

RUN_VIMTEST = VIMRUNTIME=$(VIMRUNTIME) $(VALGRIND) $(ENVVARS) ../$(VIMPROG) -f $(GUI_FLAG)

# Uncomment this line for debugging
# DEBUGLOG = --log testlog

# All initial phony targets; these names may clash with file types.
phonies = clean test testclean
.PHONY: $(phonies)

# Run the tests that didn't run yet or failed previously.
# If a test succeeds a testdir/done/{name} file will be written.
# If a test fails a testdir/failed/{name}.dump file will be written.
# Progress and error messages can be found in "testdir/messages".
# Comment out the "> /dev/null" part to see the in-progress Vim behaviors.
test:
	@# the "vimcmd" file is used by the screendump utils
	@echo "../$(VIMPROG)" > testdir/vimcmd
	@echo "$(RUN_VIMTEST)" >> testdir/vimcmd
	@# Trace ruler liveness on demand.
	@#mkdir -p testdir/failed
	@#touch "$(VIM_SYNTAX_TEST_LOG)"
	VIMRUNTIME=$(VIMRUNTIME) $(ENVVARS) $(VIMPROG) --clean --not-a-term $(DEBUGLOG) -u testdir/runtest.vim > /dev/null
	@rm -f testdir/Xfilter
	@# FIXME: Temporarily show the whole file to find out what goes wrong
	@#if [ -f testdir/messages ]; then tail -n 6 testdir/messages; fi
	@if [ -f testdir/messages ]; then cat testdir/messages; fi

# add dependence on syntax files
testdir/testdeps.mk:
	./testdir/tools/maketestdeps $(phonies) > $@

-include testdir/testdeps.mk

clean testclean:
	rm -f testdir/failed/* testdir/done/* testdir/vimcmd testdir/messages testdir/Xtestscript testdir/Xfilter testdir/testdeps.mk

# Collect all input filenames and their file types.
testnames != set +f; \
awk 'BEGIN { \
    for (i = 1; i < ARGC; i++) { \
        split(ARGV[i], names, /\//); \
        split(names[3], parts, /[._]/); \
        types[parts[1]]; \
        print names[3]; \
    } \
    delete types["vim9"]; \
    split("$(phonies)", scratch); \
    for (phony in scratch) \
        phonies[scratch[phony]]; \
    for (type in types) \
        print type ((type in phonies) ? "_" : ""); \
}' testdir/input/*.*

.PHONY: self-testing $(testnames)

$(testnames)::
	@echo $@ >> testdir/Xfilter

self-testing:: $(testnames)
	@echo self-testing > testdir/Xfilter

=== debian/changelog ===
vim (2:9.1.1230-2progress8u1) horok; urgency=medium

  * Initial upload to horok.
  * Updating maintainer field.
  * Updating uploaders field.
  * Updating bugs field.
  * Updating vcs fields.
  * Setting BUILDER to maintainers@lists.progress-linux.org.
  * Building vim with python3.
  * Building vim-gtk3 without ruby.
  * Updating debversions for Progress Linux 1 to 10.
  * Disabling mouse.
  * Disabling BufReadPost.
  * Reading configuration files in /etc/vim/vimrc.d.
  * Enabling autoindent.
  * Enabling highlight whitespace.
  * Enabling hlsearch.
  * Enabling incsearch.
  * Enabling listchars.
  * Enabling noerrorbells.
  * Enabling powerline.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 21 Jun 2025 11:24:54 +0200

vim (2:9.1.1230-2) unstable; urgency=medium

  * Backport v9.1.1242 and v9.1.1244 to fix crash when evaluating a variable
    name. (Closes: #1106133)

 -- James McCoy <jamessan@debian.org>  Thu, 22 May 2025 20:48:59 -0400

vim (2:9.1.1230-1) unstable; urgency=medium

  * Merge upstream tag v9.1.1230
    + Security fixes:
      - 9.1.1115: use-after-free in str_to_reg(), CVE-2025-26603
      - 9.1.1164: editing a specially crafted tar file allows code execution,
        (Closes: #1099610, CVE-2025-27423)
      - 9.1.1198: potential data loss with zip.vim and crafted zip files,
        (Closes: #1101016, CVE-2025-29768)

 -- James McCoy <jamessan@debian.org>  Mon, 24 Mar 2025 20:59:06 -0400

=== debian/control ===
Source: vim
Section: editors
Priority: optional
Maintainer: Progress Linux Maintainers <maintainers@lists.progress-linux.org>
XSBC-Uploaders: Daniel Baumann <daniel.baumann@progress-linux.org>
XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
XSBC-Original-Uploaders:
 James McCoy <jamessan@debian.org>,
Bugs: mailto:maintainers@lists.progress-linux.org
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 cscope <!nocheck>,
 debhelper-compat (= 13),
 libacl1-dev,
 libcanberra-dev,
 libgpmg1-dev [linux-any],
 libgtk-3-dev,
 liblua5.1-dev,
 libmotif-dev,
 libperl-dev,
 libselinux1-dev [linux-any],
 libsodium-dev,
 libncurses-dev,
# Needed to run libvterm's tests
 libtool-bin <!nocheck>,
 locales-all <!nocheck>,
 lua5.1,
 ncurses-term <!nocheck>,
 procps <!nocheck>,
 python3-dev,
 ruby [!alpha !ia64] <!pkg.vim.noruby>,
 ruby-dev [!alpha !ia64] <!pkg.vim.noruby>,
 tcl-dev,
Build-Conflicts:
 autoconf2.13,
Build-Depends-Indep:
 docbook-utils,
 docbook-xml,
 ghostscript,
# Explicitly depend on lynx since docbook2txt requires it, even though its
# Depends suggests otherwise (c.f., #387035)
 lynx,
 pdf2svg,
Vcs-Browser: https://git.progress-linux.org/horok/vim
Vcs-Git: https://git.progress-linux.org/horok/vim
XSBC-Original-Vcs-Browser: https://salsa.debian.org/vim-team/vim
XSBC-Original-Vcs-Git: https://salsa.debian.org/vim-team/vim.git
Homepage: https://www.vim.org/

Package: vim-common
Priority: important
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 xxd,
 vim | vim-gtk3 | vim-motif | vim-nox | vim-tiny,
Breaks: vim-runtime (<< 2:9.0.1658-1~)
Replaces: vim-runtime (<< 2:9.0.1658-1~)
Description: Vi IMproved - Common files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains files shared by all non GUI-enabled vim variants
 available in Debian.  Examples of such shared files are: manpages and
 configuration files.

Package: vim-gui-common
Architecture: all
Multi-Arch: foreign
Recommends:
 vim-gtk3 | vim-motif,
Depends:
 ${misc:Depends},
Description: Vi IMproved - Common GUI files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains files shared by all GUI-enabled vim
 variants available in Debian.  Examples of such shared files are:
 gvimtutor, icons, and desktop environments settings.

Package: vim-runtime
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Breaks:
 vim-tiny (<< ${source:Version}),
Recommends:
 vim | vim-gtk3 | vim-motif | vim-nox | vim-tiny,
Enhances:
 vim-tiny,
Description: Vi IMproved - Runtime files
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains vimtutor and the architecture independent runtime
 files, used, if available, by all vim variants available in Debian.
 Example of such runtime files are: online documentation, rules for
 language-specific syntax highlighting and indentation, color schemes,
 and standard plugins.

Package: vim-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Vi IMproved - HTML documentation
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains the HTML version of the online documentation.  It is
 built from the runtime/doc directory of the source tree.

Package: vim-tiny
Priority: important
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 indent,
Provides:
 editor,
Description: Vi IMproved - enhanced vi editor - compact version
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 This package contains a minimal version of Vim compiled with no GUI and
 a small subset of features. This package's sole purpose is to provide
 the vi binary for base installations.
 .
 If a vim binary is wanted, try one of the following more featureful
 packages: vim, vim-nox, vim-motif, or vim-gtk3.

Package: vim
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ctags,
 vim-doc,
 vim-scripts,
Provides:
 editor,
Description: Vi IMproved - enhanced vi editor
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a rather
 standard set of features.  This package does not provide a GUI
 version of Vim.  See the other vim-* packages if you need more
 (or less).

Package: vim-gtk3
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-gui-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 fonts-dejavu,
 gnome-icon-theme,
 vim-doc,
Provides:
 editor,
 gvim (= ${binary:Version}),
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with GTK3 GUI
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a GTK3 GUI
 and support for scripting with Lua, Perl, Python 3,${vim:Ruby-Desc} and Tcl.

Package: vim-nox
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 vim-doc,
Provides:
 editor,
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with scripting languages support
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with support for
 scripting with Lua, Perl, Python 3,${vim:Ruby-Desc} and Tcl but no GUI.

Package: vim-motif
Architecture: any
Depends:
 vim-common (= ${source:Version}),
 vim-gui-common (= ${source:Version}),
 vim-runtime (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 cscope,
 vim-doc,
Provides:
 editor,
 gvim (= ${binary:Version}),
 vim (= ${binary:Version}),
 vim-lua (= ${binary:Version}),
 vim-perl (= ${binary:Version}),
 vim-python3 (= ${binary:Version}),
 ${vim:Ruby-Provides},
 vim-tcl (= ${binary:Version}),
Description: Vi IMproved - enhanced vi editor - with Motif GUI
 Vim is an almost compatible version of the UNIX editor Vi.
 .
 Many new features have been added: multi level undo, syntax
 highlighting, command line history, on-line help, filename
 completion, block operations, folding, Unicode support, etc.
 .
 This package contains a version of vim compiled with a Motif GUI
 and support for scripting with Lua, Perl, Python 3,${vim-Ruby-Desc} and Tcl.

Package: vim-athena
Architecture: all
Depends:
 vim-motif,
 ${misc:Depends},
Section: oldlibs
Description: Vi IMproved - enhanced vi editor (dummy package)
 This is a transitional package to install the vim-motif package.  You may
 remove this package if nothing depends on it.

Package: xxd
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: tool to make (or reverse) a hex dump
 xxd creates a hex dump of a given file or standard input.  It can also convert
 a hex dump back to its original binary form.

=== debian/rules ===
#!/usr/bin/make -f

export DH_OPTIONS

# Upstream handles the _FORTIFY_SOURCE flag on their own
DEB_BUILD_MAINT_OPTIONS = hardening=+all,-fortify future=+lfs

include /usr/share/dpkg/default.mk

BUILDER = maintainers@lists.progress-linux.org

# Work around #1082125
ifeq (s390x,$(DEB_HOST_ARCH))
  CFLAGS += -O1
endif

MAKETEST = no
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  MAKETEST = yes
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

RUBY_SUBSTVARS = -Vvim:Ruby-Provides= -Vvim:Ruby-Desc=
RUBY_CFGFLAGS = --disable-ruby

# Set to TEST_SKIP_PAT=<vim pattern> to exclude running tests matching the pattern
EXCLUDE_PAT = TEST_SKIP_PAT='Test_crash1\|glvs'

CFGFLAGS = --prefix=/usr --mandir='$${prefix}'/share/man --without-local-dir
CFGFLAGS += --with-modified-by="$(BUILDER)"
CFGFLAGS += --with-compiledby="$(BUILDER)"
CFGFLAGS += --enable-fail-if-missing
CFGFLAGS += --with-global-runtime='/var/lib/vim/addons,/etc/vim,$$VIM/vimfiles'

TINYFLAGS = --with-features=small
TINYFLAGS += --disable-gui
TINYFLAGS += --disable-xsmp
TINYFLAGS += --disable-xsmp-interact
TINYFLAGS += --disable-netbeans
TINYFLAGS += --disable-gpm
TINYFLAGS += --enable-nls
TINYFLAGS += --enable-acl
TINYFLAGS += --disable-terminal
TINYFLAGS += --disable-canberra
TINYFLAGS += --disable-libsodium

OPTFLAGS = --enable-cscope
ifeq ($(DEB_HOST_ARCH_OS),linux)
    OPTFLAGS += --enable-gpm
    OPTFLAGS += --enable-selinux --disable-smack
    TINYFLAGS += --enable-selinux --disable-smack
else
    OPTFLAGS += --disable-gpm
endif
OPTFLAGS += --with-features=huge
OPTFLAGS += --enable-acl
OPTFLAGS += --enable-terminal
OPTFLAGS += --enable-libsodium

NOXFLAGS = --without-x
NOXFLAGS += --enable-gui=no
NOXFLAGS += --disable-canberra

GUIFLAGS = --with-x
GUIFLAGS += --enable-xim
GUIFLAGS += --enable-canberra

GTK3FLAGS = --enable-gui=gtk3
GTK3FLAGS += --enable-gtk3-check
GTK3FLAGS += --disable-gnome-check
GTK3FLAGS += --disable-motif-check
GTK3FLAGS += --disable-motif-check
GTK3FLAGS += --disable-fontset

MOTIFFLAGS = --enable-gui=motif
MOTIFFLAGS += --disable-gtk2-check
MOTIFFLAGS += --disable-gtk3-check
MOTIFFLAGS += --disable-gnome-check
MOTIFFLAGS += --disable-motif-check
MOTIFFLAGS += --enable-motif-check
MOTIFFLAGS += --enable-fontset

NOINTERPFLAGS = --disable-luainterp
NOINTERPFLAGS += --disable-mzschemeinterp
NOINTERPFLAGS += --disable-perlinterp
NOINTERPFLAGS += --enable-python3interp --with-python3-config-dir=$(shell python3-config --configdir)
NOINTERPFLAGS += --disable-pythoninterp
NOINTERPFLAGS += --disable-rubyinterp
NOINTERPFLAGS += --disable-tclinterp

ALLINTERPFLAGS = --enable-luainterp
ALLINTERPFLAGS += --disable-mzschemeinterp
ALLINTERPFLAGS += --enable-perlinterp
ALLINTERPFLAGS += --enable-python3interp --with-python3-config-dir=$(shell python3-config --configdir)
ALLINTERPFLAGS += --disable-pythoninterp
ALLINTERPFLAGS += --enable-tclinterp
ALLINTERPFLAGS += --with-tclsh=/usr/bin/tclsh

# Each vim-xxx package is said to be a vim variant and contains only a vim
# binary built with some compile-time options. Makefile VARIANTS below are
# one-to-one with those packages with the exception of "vim-basic". In this
# Makefile vim-basic is used to build 4 packages: "vim", "vim-runtime",
# "vim-common", "vim-gui-common". "vim-tiny" is the only variant package not
# depending on vim-runtime.

VARIANTS += vim-tiny
VARIANTS += vim-gtk3
VARIANTS += vim-motif
VARIANTS += vim-nox
VARIANTS += vim-basic

ifneq ($(origin VARIANT), undefined)
  VARIANTS = $(VARIANT) vim-basic
endif

CFLAGS += -DSYS_VIMRC_FILE="'\"/etc/vim/vimrc\"'" -DSYS_GVIMRC_FILE="'\"/etc/vim/gvimrc\"'"

CFLAGS_vim-basic = $(CFLAGS)
CFGFLAGS_vim-basic = $(CFGFLAGS) $(OPTFLAGS) $(NOXFLAGS) $(NOINTERPFLAGS)

CFLAGS_vim-tiny = $(CFLAGS) -DTINY_VIMRC -DSYS_TINYRC_FILE="'\"/etc/vim/vimrc.tiny\"'"
CFGFLAGS_vim-tiny = $(CFGFLAGS) $(TINYFLAGS)

CFLAGS_vim-gtk3 = $(CFLAGS)
CFGFLAGS_vim-gtk3 = $(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(ALLINTERPFLAGS) $(GTK3FLAGS) $(RUBY_CFGFLAGS)

CFLAGS_vim-motif = $(CFLAGS)
CFGFLAGS_vim-motif = $(CFGFLAGS) $(OPTFLAGS) $(GUIFLAGS) $(MOTIFFLAGS) $(ALLINTERPFLAGS) $(RUBY_CFGFLAGS)

CFLAGS_vim-nox = $(CFLAGS)
CFGFLAGS_vim-nox = $(CFGFLAGS) $(OPTFLAGS) $(NOXFLAGS) $(ALLINTERPFLAGS) $(RUBY_CFGFLAGS)

NAME = vim
# Convert x.y.z to x.y
VERSION = $(basename $(DEB_VERSION_UPSTREAM))
VIMMAJOR = $(basename $(VERSION))
VIMCUR = $(NAME)$(subst .,,$(VERSION))
LANGS = da de fr it ja pl ru tr

DOT_IN_DEPS = debian/vim-runtime.postrm
DOT_IN_DEPS += debian/vim-runtime.preinst
DOT_IN_DEPS_TINY = debian/tiny/vimrc.tiny

foreach-variant = \
  set -e; for v in $(VARIANTS); do \
    $1; \
  done

%:
	dh $@

update-changelog:
	dh_testdir
	wget -O debian/changelog.upstream http://ftp.vim.org/pub/vim/patches/$(VERSION)/README

override_dh_auto_clean:
# The vim-basic variant is always enabled, so we can rely on it when checking
# whether we can call "make distclean".  The config.cache check is to avoid
# calling make when configure has not run, otherwise make will run configure to
# generate an include file
	[ ! -f src/vim-basic/auto/config.cache ] || make distclean
	[ ! -f debian/configure.dist ] || mv debian/configure.dist src/auto/configure
	find src/testdir -name '*.pyc' -delete
	for v in $(VARIANTS); do \
	  if [ "$${v}" = vim-basic ]; then \
	    [ ! -L src/"$${v}"/po ] || $(MAKE) -C src/"$${v}"/po clean; \
	  fi; \
	  rm -rf src/"$${v}"; \
	done
	rm -f $(DOT_IN_DEPS)
	rm -f $(DOT_IN_DEPS_TINY)

override_dh_auto_configure-indep: autoconf-stamp
	$(MAKE) -f debian/rules configure-vim-basic

override_dh_auto_configure-arch: autoconf-stamp
	$(call foreach-variant, $(MAKE) -f debian/rules configure-"$${v}")

override_dh_auto_build-indep: autoconf-stamp
override_dh_auto_build-indep:
	$(MAKE) -f debian/rules build-vim-basic
	$(MAKE) -C runtime/doc html
	$(MAKE) -C debian/policy text html
	$(MAKE) -C src/po vim.pot VIMPROG=$(CURDIR)/src/vim-basic/vim

override_dh_auto_build-arch: autoconf-stamp
	$(call foreach-variant, $(MAKE) -f debian/rules build-"$${v}")
	$(MAKE) -C src/vim-basic xxd/xxd

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	$(call foreach-variant, $(MAKE) -f debian/rules test-"$${v}")

autoconf-stamp:
	dh_testdir
	[ -f debian/configure.dist ] || cp src/auto/configure debian/configure.dist
# The autoconf target generates a new configure, and touches some other
# configure-related things.  Need to run scratch afterward or timestamps
# will be off and the next make that runs will think it needs to run
# configure.  This breaks parallel builds since two configures are being run
# in the same directory at the same time instead of in their own shadow
# directories.
	$(MAKE) -C src autoconf
	$(MAKE) -C src scratch
	touch $@

src/vim-%: VARIANT=vim-$*
src/vim-%:
	$(MAKE) -C src shadow SHADOWDIR=$(VARIANT)

configure-vim-%: VARIANT=vim-$*
configure-vim-%: autoconf-stamp
configure-vim-%:
	$(MAKE) -f debian/rules src/$(VARIANT)
	cd src/$(VARIANT) && LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS_$(VARIANT))" ./configure $(CFGFLAGS_$(VARIANT))

build-vim-%: VARIANT=vim-$*
build-vim-%: configure-$(VARIANT)
build-vim-%:
	$(MAKE) -C src/$(VARIANT)
	$(MAKE) -C runtime/doc tags VIMPROG=$(CURDIR)/src/$(VARIANT)/vim

test-vim-%: VARIANT=vim-$*
test-vim-%:
	:
ifeq (yes,$(MAKETEST))
# Sanitize LC_* env so they don't leak through to child processes and cause problems in build chroots (e.g., missing locales)
# and set sane values for TERM/LC_ALL/LANG
	for e in ADDRESS COLLATE CTYPE IDENTIFICATION MEASUREMENT MESSAGES MONETARY NAME NUMERIC PAPER TELEPHONE TIME; do \
	  unset LC_$${e}; \
	done; \
	env $(EXCLUDE_PAT) TERM=xterm LC_ALL=C.UTF-8 LANG=C.UTF-8 $(MAKE) -j1 -C src/$(VARIANT) test
endif

override_dh_auto_install-arch:

# Use UTF-8 manpages for all languages
# If a .UTF-8 directory doesn't exist, then the $L directory is already UTF-8.
define munge-man-directories
for L in $(LANGS); do \
